# C# PDF library to create, edit, draw and print PDF files

![Latest Docotic.Pdf version on NuGet](https://img.shields.io/nuget/vpre/BitMiracle.Docotic.Pdf?logo=nuget&label=Latest%20version) [![Regression tests result](https://img.shields.io/badge/Regression_tests-%E2%9C%93%2014%2C582_passed-34d058?logo=visualstudio)](https://bitmiracle.com/pdf-library/howto/unit-testing) [![Sample code on GitHub](https://img.shields.io/badge/Code_samples-%E2%9C%93%20-107C10?logo=github)](https://github.com/BitMiracle/Docotic.Pdf.Samples)

Docotic.Pdf is the .NET PDF library for .NET Core, ASP.NET, Windows Forms, WPF, Xamarin, Blazor, Unity, and HoloLense applications. 

[Getting started](https://bitmiracle.com/pdf-library/getting-started#using) | [Features](https://bitmiracle.com/pdf-library/help) | [Licensing](https://bitmiracle.com/pdf-library/licenses/) | [Free Trial](https://bitmiracle.com/pdf-library/download)

The library is a 100% managed assembly without unsafe blocks. The assembly has no external dependencies. 

[![Docotic.Pdf library banner](https://raw.githubusercontent.com/BitMiracle/nuget-assets/main/core-readme/docotic.pdf-banner.svg)](https://bitmiracle.com/pdf-library/)

## Features

Use Docotic.Pdf to:
* Create PDF documents using [Canvas API](https://github.com/BitMiracle/Docotic.Pdf.Samples/tree/master/Samples/Graphics). 
* [Generate PDF reports, invoices, etc.](https://bitmiracle.com/pdf-library/create-pdf) using the fluent API provided by the Layout add-on. 
* [Extract text from PDF documents](https://bitmiracle.com/pdf-library/pdf-text/extract). 
* [Convert HTML to PDF in C#](https://bitmiracle.com/pdf-library/html-pdf/convert) with the help of the HTML to PDF converter add-on.
* [Convert PDF to image](https://bitmiracle.com/pdf-library/pdf-image/convert) and [print PDF documents](https://bitmiracle.com/pdf-library/draw-print-pdf).
* [Add digital signatures to PDF documents](https://bitmiracle.com/pdf-library/signatures/sign).
* [Encrypt](https://bitmiracle.com/pdf-library/passwords/encrypt) and [decrypt](https://bitmiracle.com/pdf-library/passwords/decrypt) PDF files.
* [OCR PDF files](https://bitmiracle.com/blog/ocr-pdf-in-net).
* [Merge PDF in C#](https://github.com/BitMiracle/Docotic.Pdf.Samples/tree/master/Samples/General%20operations/MergeDocuments) or VB.NET code. [Split PDF](https://github.com/BitMiracle/Docotic.Pdf.Samples/tree/master/Samples/Pages%20and%20Navigation/ExtractPages) documents.
* [Compress PDF files](https://bitmiracle.com/pdf-library/optimize/compress).
* [Linearize PDF](https://github.com/BitMiracle/Docotic.Pdf.Samples/tree/master/Samples/General%20operations/LinearizeDocument) files. Optimize for Fast Web View.
* [Edit PDF files](https://github.com/BitMiracle/Docotic.Pdf.Samples/tree/master/Samples/Pages%20and%20Navigation/EditPageContent). 


Docotic.Pdf supports .NET 8, .NET 7, .NET 6, .NET 5, .NET Standard / .NET Core, and .NET 4.x frameworks. You can use the library in .NET on Windows, Linux, macOS, Android, and iOS. Works in Azure, AWS and other cloud environments. Can be used from a Docker container.

## Documentation

For documentation, sample code, and API reference, visit [the Docotic.Pdf help page](https://bitmiracle.com/pdf-library/help).

Here are some of the more popular topics:
* [HTML to PDF](https://bitmiracle.com/pdf-library/html-pdf/)
* [PDF to text](https://bitmiracle.com/pdf-library/pdf-text/)
* [PDF to image](https://bitmiracle.com/pdf-library/pdf-image/)
* [Digital signatures](https://bitmiracle.com/pdf-library/signatures/)
* [Passwords](https://bitmiracle.com/pdf-library/passwords/)
* [How-to articles](https://bitmiracle.com/pdf-library/howto/)

## Add-ons

There are free add-ons to the library:
* [HTML to PDF add-on](https://www.nuget.org/packages/BitMiracle.Docotic.Pdf.HtmlToPdf/)
* [Layout add-on](https://www.nuget.org/packages/BitMiracle.Docotic.Pdf.Layout/)
* [Gdi add-on](https://www.nuget.org/packages/BitMiracle.Docotic.Pdf.Gdi/)
* [Logging add-on](https://www.nuget.org/packages/BitMiracle.Docotic.Pdf.Logging/)

## Licenses

Get a free time-limited license using [the form on the Docotic.Pdf page](https://bitmiracle.com/pdf-library/) to test the library without [evaluation mode restrictions](https://bitmiracle.com/pdf-library/trial-restrictions).

We offer royalty-free [licenses for Docotic.Pdf](https://bitmiracle.com/pdf-library/licenses/). Eligible projects and/or people can receive [license for the C# PDF library free of payment](https://bitmiracle.com/pdf-library/licenses/free).
